<?php 
	header('Content-Type:application/json');
	class Utils{

		public static function merge_local($arr1 , $arr2 , $country){

			foreach($arr1 as $key => $value){

				foreach($arr2 as $key2 => $value2){
					if($value['Country'] == $value2["Country"] && $country == $value["ISOCode"]){
						$value2["Country"] = $value["Country"];
						$value2["ISOCode"] = $value["ISOCode"];
						$x = new CountryAbstract();
						$x->create_sipri($value2);
						return $x;
					}
				}
			}
			return null;
		}
		public static function get_wdt($url, $type){

			$ch = curl_init(); 
		    // set url 
		    curl_setopt($ch, CURLOPT_URL, $url); 
		    //return the transfer as a string 
		    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
		    // $output contains the output string 
		    $data = json_decode(curl_exec($ch) , true); 
		    // close curl resource to free up system resources 
		    curl_close($ch);  
		    $countryModel = new CountryAbstract();
		    $countryModel->create_wdb($data[1]);
		    return $countryModel;
		}

	}
	class CountryAbstract{
		public $Country;
		public $Id;
		public $data = array();

		public function create_sipri($obj){
			$this->Country = $obj["Country"];
			$this->Id = $obj["ISOCode"];
			$this->data = array("");
			for($i = 2000; $i <= 2015; $i++){
				$this->data[] = array("year" => $i , "value" => $obj[$i]);
			}
		}

		public function create_wdb($obj){

			if(count($obj)>0){
				foreach($obj as $key => $value){
						//print_r($value);
					$this->data[] = array("year" => $value["date"] , "value" => (float)$value["value"]);
				}
			}
				
		}

		public function create_percentage($gdp , $exp)
		{
			if(count($exp) > 0 & count($gdp) > 0){
				foreach($exp as $key => $value)
			    {
			        foreach($gdp as $key_gdp => $value_gdp)
			        {
			            if($value['year'] == $value_gdp['year'])
			            {
			                $val = ((float)((float)$value['value'] * (float)$value_gdp['value']) / 100.0 );
			            	
			                $this->data[] = array("year" => $value["year"] , "value" => $val);
			            }
			        }
			    }
			}
			
		}

	}

	if(!$_GET['countryid']){
		print_r(json_encode(array("success" => false ,  "Message" => "No data")));
		die;
	}

	$resp = array(
		"Country" => $_GET['countryid'],
		"Imports" => null ,
		"Exports" => null ,
		"Expenditure" => null ,
		"GDP" => null,
		"Percentage" => null
	);

	$json_url = "data/countrycode.json";
	$countries = file_get_contents($json_url);

	 //IMPORTS

	$json_url = "data/imports.json";
	$imports = file_get_contents($json_url);

	//print_r($imports);
	$imports = Utils::merge_local(json_decode($countries,true) , json_decode($imports,true) , $_GET['countryid']);

	$resp["Imports"] = $imports;
	//EXPORTS


	$json_url = "data/exports.json";
	$exports = file_get_contents($json_url);

	$exports = Utils::merge_local(json_decode($countries,true) , json_decode($exports,true) , $_GET['countryid']);

	$resp["Exports"] = $exports;

	//EXPENDITURE

	/*
		http://api.worldbank.org/countries/COUNTRY/indicators/MS.MIL.XPND.ZS?per_page=50&date=2000:2015&format=json
	*/
	$exp_url = "http://api.worldbank.org/countries/".$_GET["countryid"]."/indicators/MS.MIL.XPND.ZS?per_page=50&date=2000:2015&format=json";

	$expenditure = Utils::get_wdt($exp_url , $_GET["countryid"]);
	$resp["Expenditure"] = $expenditure;

	//GDP
	/*
		http://api.worldbank.org/countries/COUNTRY/indicators/NY.GDP.MKTP.PP.CD?per_page=50&date=2000:2015&format=json
	*/

	$gdp_url = "http://api.worldbank.org/countries/".$_GET["countryid"]."/indicators/NY.GDP.MKTP.PP.CD?per_page=50&date=2000:2015&format=json";

	$gdp = Utils::get_wdt($gdp_url , $_GET["countryid"]);

	$resp["GDP"] = $gdp;

	//GDP-EXPENDITURE
	$countryModel = new CountryAbstract();
	$countryModel->create_percentage($resp["GDP"]->data ,$resp["Expenditure"]->data);
	$resp["Percentage"] = $countryModel;


	print_r(json_encode(array("success"=>true, "data" => $resp)));
?>