app = angular.module('visualization' , [
	'ui.router' ,
	'nvd3'  ,
	'ui.bootstrap',
	'ui.bootstrap.tpls',
	'datamaps',
  'ngAnimate',
  'ngRangeSlider',
  'ngAnimate',
  'ngSanitize'
])
app.config(function($stateProvider, $urlRouterProvider , $locationProvider ) {
  
  $urlRouterProvider.otherwise("/");
  $locationProvider.html5Mode(true)
  // Creació dels estats (pantalles)
  $stateProvider
  .state('home', {
  	url: "/",
  	controller : "HomeCtrl",
  	templateUrl: "/views/home.html"
  })
  .state('statistics', {
  	url: "/statistics/:id",
  	controller : "StatisticsCtrl",
  	templateUrl: "/views/statistics.html"
  })
  .state('map', {
  	url: "/map/:id",
  	controller : "MapCtrl",
  	templateUrl: "/views/map.html"
  })
  .state('expenditure', {
    url: "/expenditure/:id",
    controller : "ExpenditureCtrl",
    templateUrl: "/views/map.html"
  })
  .state('country', {
    url: "/country/:id",
    controller : "CountryCtrl",
    templateUrl: "/views/country.html"
  })
  .state('credits', {
    url: "/credits/",
    templateUrl: "/views/credits.html"
  });
})
// Directiva per evitar error als ng-repeat
.directive('endRepeat', ['$timeout', function ($timeout) {
	return {
		restrict: 'A',
		link: function (scope, element, attr) {
			if (scope.$last === true) {
				$timeout(function () {
					scope.$emit('ngRepeatFinished');
				});
			}
		}
	}
}])
// Directiva de pantalla bloquejadora al càrregar dades externer (ajax)
.directive('loading',   ['$http' ,function ($http)
{
    return {
        restrict: 'A',
        link: function (scope, elm, attrs)
        {
            scope.isLoading = function () {
                return $http.pendingRequests.length > 0;
            };
            scope.$watch(scope.isLoading, function (v)
            {
                if(v){
                    elm.show();
                }else{
                    elm.hide();
                }
            });
        }
    };
}])