var fills = [
	    'LOW-XS','LOW',
	    'MEDIUM-L','MEDIUM','MEDIUM-H',
	    'HIGH','HIGHXL'
    ];
function Bubble(obj , year , x){
	try{
		this.info = {
			Country : obj.Country,
			Region : obj.region.value ? obj.region.value : "",
			Values: [{key : obj.Country , values : []}],
			Id : obj.id
		}

		for(i = 2000 ; i <= 2015 ; i++){
			this.info.Values[0].values.push( { x : i , y : obj[i]});
		}
		this.name = "<h4>" + obj.Country + "</h4><p class='text-popup'>Despesa militar: </p><p><big>" + obj[year] +"M$</big></p>";
		this.radius = obj[year] / 50;
		this.value = obj[year];
		this.latitude = obj.latitude;
		this.longitude = obj.longitude;
		this.pos = parseInt(x(obj[year]))
		this.fillKey = fills[this.pos];
	}catch(e){
		console.log(e)
	}
	
}
function BubbleYear(obj , year , x){

	this.info = {
		Country : obj.country,
		Region : obj.region.value ? obj.region.value : "",
		Values: [{key : obj.country , values : []}],
		Id : obj.id
	}

	this.name = "<h4>" + obj.country + "</h5><p>Year " +year 
	+"</br>% Military Expenditure on GDP:<big><b>" + parseFloat(obj.percentage.toFixed(2)) +"%</b></big>"
	+"</br>Military Expenditure:<big><b>" + parseFloat(obj.expenditure.toFixed(2)) +"$</b></big>"
	+"</br>GDP:<big><b>" + parseFloat(obj.gdp.toFixed(2)) +"$</b></big>"
	+"</p>";

	this.name = "<h5>" + obj.country + " </h4><small>(" + obj.percentage.toFixed(2) +")%</small>";
	this.radius = obj.percentage ;
	this.latitude = obj.latitude;
	this.longitude = obj.longitude;
	this.pos = parseInt(x(obj.percentage))
	this.fillKey = fills[this.pos];
}
function Arc(_from, _to , countries){
	var origin = Enumerable.From(countries).Where("$.id == '" + _from + "'").First();
	var destination = Enumerable.From(countries).Where("$.id == '" + _to + "'").First();
	this.origin = new LatLng(origin.latitude , origin.longitude)
	this.destination = new LatLng(destination.latitude , destination.longitude)
}
function LatLng(lat,lng){
	this.latitude = lat;
	this.longitude = lng;
}
function BarChart(obj , color){
	console.log(obj)
	if(!color)
		color = 0
	this.key = obj.Country;
	this.country = obj.Country;
	this.id = obj.id;
	this.latitude = obj.latitude;
	this.longitude = obj.longitude;
	this.values = []
	var country = {
		values : [],
		key: obj.Country,
        color: color
	}
	for(i = 2000 ; i <= 2015 ; i++){
		var values = { x : i , y : obj[i]};
		country.values.push(values)
	}
	console.log(country)
	this.values.push(country);
}

function ScatterChart(obj , color , count){
	if(!color)
		color = 0

	shapes = ['circle', 'cross', 'triangle-up', 'triangle-down', 'diamond', 'square']

	this.key = obj.country;
	this.color = color;
	this.values = [
			{
				x : obj.expenditure,
				y : obj.gdp,
				size : obj.percentage ,
				shape : shapes[count % 6],
				series : count
			}
		]
	this.country = obj.country;
	this.id = obj.id;
	this.latitude = obj.latitude;
	this.longitude = obj.longitude;
	
}

function CountryData(resp , obj){
	this.info = obj;
	this.imports = apiToData(resp.Imports , obj.name);
	this.exports = apiToData(resp.Exports, obj.name);
	this.expenditure = apiToData(resp.Expenditure, obj.name);
	this.gdp = apiToData(resp.GDP, obj.name);
	this.percentage = apiToData(resp.Percentage, obj.name);
}
function apiToData(obj , country){
	var ret = [{
		key : country,
		values : []
	}]
	try{
		angular.forEach(obj.data , function(v,k){
			if(v.value && v.value != null)
				ret[0].values.push({x:  parseFloat(v.value.toFixed(2)) , y : v.year})
		})
	}catch(e){

	}
		
	return ret
	
}