
app.controller('ExpenditureCtrl' , [
	'$scope' ,
	'$timeout',
	'$window',
	'DataInfo' ,
	'$http',
	'$state',
	'$interval',
	'$timeout',
	'$rootScope',
 function(s,timeout, $window , DataInfo , $http , $state , $interval , $timeout, $rootScope) {
	//Setejament de l'anu inicial
	s.year = 2000;

	s.$watch( 'year' , function(x){
		$rootScope.year = parseInt(s.year);
	});
	// Listener per modificar els colors dels rangs
	$rootScope.$watch('pallette', function(x){
		s.mapObject.data = x
	})

	// Anys disponibles
	s.years = [2000,2001,2002,2003,2004,2005,2006,2007,2008,2009,2010,2011,2012,2013,2014,2015];
	s.filters = true;
	/*
		Setejament del tipus de dades segons els parametres vinguts per la URL
	*/
 	if(!$state.params.id) 
 		$state.params.id = 'imports';
	s.title = "Despesa militar";
	s.showControls = true;
	s.activemenu = 'expenditure';
	
	// Configuració del gràfic del popup
	s.summary_options ={
		chart : {
            type: 'lineChart',
            height: 150,
            width: 250,
            margin : {
                top: 20,
                right: 20,
                bottom: 40,
                left: 55
            },
            color :['#bf1925'],
            x: function(d){ return d.x; },
            y: function(d){ return d.y; },
            useInteractiveGuideline: true,
            yAxis : {
            	axisLabel : "Despesa Militar (MM$)",
            	axisLabelDistance: -10,
            	tickFormat : function(x){
            		return x.toFixed(1)
            	}
            }
        }
    }
    // Configuració pel gràfic de la pantalla estadístiques
	DataInfo.type = {
		chart :{
	        type: 'scatterChart',
	        height: $(document).height() - 150,
	        color: d3.scale.category10().range(),
	        scatter: {
	            onlyCircles: false
	        },
	        showDistX: true,
	        showDistY: true,
	        tooltipContent: function(key) {
	            return '<h3>' + key + '</h3>';
	        },
	        duration: 350,
	        xAxis: {
	            axisLabel: 'X Axis',
	            tickFormat: function(d){
	                return d3.format('.02f')(d);
	            }
	        },
	        yAxis: {
	            axisLabel: 'Y Axis',
	            tickFormat: function(d){
	                return d3.format('.02f')(d);
	            },
	            axisLabelDistance: 30
	        },
	        zoom: {
	            //NOTE: All attributes below are optional
	            enabled: true,
	            scaleExtent: [1, 10],
	            useFixedDomain: false,
	            useNiceScale: false,
	            horizontalOff: true,
	            verticalOff: true,
	            unzoomEventType: 'dblclick.zoom'
	        },
	        title: {
	            enable: true,
	            text: $state.params.id + " of " + s.country,
	            css:{
	                'font-size':'3vw;'
	            }
	        }
	    }
    };
	s.info = DataInfo;
	s.menu = {
		filter : false,
		menu: false
	}
	// Configuració del mapa
	s.mapObject = {
	  scope: 'world',
	  options: {
	  },
	  responsive: true,
	  fills: DataInfo.pallette,
	}
	s.mapPlugins = {
		arc : null,
	  	bubbles: null,
	}
	s.mapPluginData = {
	  bubbles: [],
	  arc : []
	};
	s.tooltip = {
		info : null,
		show : false,
		position : {top : 0 , left : 0 }
	}
	// Funcions per poder arrossegar el pop-up de país
	$(function() {
	    $( ".custom-tooltip" ).draggable();
	  });
	$('*').bind( "touchstart", function(e){return true});
	$($('datamap')).on('click', '.datamaps-bubble', function(e) {
	  //handle click here as well
	  var info = angular.fromJson($(this).attr('data-info'));
	  s.$apply(function(){
		  s.tooltip.position.top = e.clientY +'px'
		  s.tooltip.position.left = e.clientX + 'px'
		  s.tooltip.info = info.info;
		  s.tooltip.show = true;
		  $http.get('request_country.php?country=' + info.info.Id )
		  .success(function(x){
	  	  		var z = Enumerable.From(x).Select(function(d){
		  	 		return { x : d.year , y : d.percentage}
	  	 		}).ToArray();
			  	s.tooltip.info.Values[0].values = z;
		  });
	    })
	})

	// Funció que agafa les dades del JSON i les posa al mapa
	s.getData = function(){
		$http.get('request_expenditure.php?year=' + s.year )
		.success(function(d){
			
			var _bubles = Enumerable.From(d)
			.Join(s.info.map , "$.country" , "$.name" , function(x,y){
				return angular.merge(x,y);
			}).OrderByDescending("$.percentage").ToArray();

			s.current_data = _bubles;
			var year = s.year;
			s.min = Enumerable.From(_bubles).Where("$.percentage > 0").Min("$.percentage").toFixed(2)
			s.max = Enumerable.From(_bubles).Where("$.percentage > 0").Max("$.percentage").toFixed(2)

			s.scale = d3.scale.linear()
                    .domain([s.min, s.max])
                    .range([0,5]);
            if(s.year <= 2015 && s.year >= 2000){
				s.mapPluginData.bubbles = Enumerable.From(s.current_data).Select(function(x){
					var _bubble = new BubbleYear(x ,s.year ,s.scale)
					return _bubble;
				}).ToArray();
			}else if(s.year >2015){
				s.year = 2015;
			}else{
				s.year = 2000;
			}
		})
	}
	// Funció que permet canviar l'anu que es visualitza
	s.changeYear = function(f){
		if(angular.isDefined(stop)) {
			$interval.cancel(stop)
			stop = null;
			s.stop = false;
		}
		s.year = f;
	  	s.getData();
	}
	
	s.hidemenu = function(type){
		s.menu[type] = false;
	}
	s.$on('readyto' , function(x,i){
		s.getData();
	});

	if(s.info.map){
		s.getData();
	}
	s.resetData = function(){
		s.data.values = [];
		localStorage.removeItem('DataInfo');
	}
    s.country = null;
    s.data = {values : []}

    // Funció que permet afegir un país amb les seves dades als filtres
    s.selectCountry = function(model){
    	_data = s.current_data;
    	s.current_country = Enumerable.From(s.current_data).Where("$.id == '" + model + "'").ToArray();
    	if(s.current_country.length){
    		var country = new ScatterChart(s.current_country[0] , DataInfo.pallette[fills[s.data.values.length % 6]] ,s.data.values.length );
    		s.data.values.push(country);
    	}
    	DataInfo.graphic = s.data
    	localStorage.setItem('DataInfo' , angular.toJson(DataInfo));
    }
    s.removeData = function(key){
		s.data.values = Enumerable.From(s.data.values).Where("$.key != '" + key +"'").ToArray()
    }
    if(DataInfo.graphic)
		s.data = DataInfo.graphic;


	s.setYear = function(year){
		
		s.year = year;
		
		if(angular.isDefined(stop)) {
			$interval.cancel(stop)
			stop = null;
			s.stop = false;
		}
		s.getData()
	}
}]);
var _data = {}