app.controller('MapCtrl' , [
	'$scope' ,
	'$timeout',
	'$window',
	'DataInfo' ,
	'$http',
	'$state',
	'$interval',
	'$rootScope',
 function(s,timeout, $window , DataInfo , $http , $state , $interval , $rootScope) {
 	//Setejament de l'anu inicial
	s.year = 2000;
	
	s.$watch( 'year' , function(x){
		$rootScope.year = parseInt(s.year);
	});
	// Anys disponibles
	s.years = [2000,2001,2002,2003,2004,2005,2006,2007,2008,2009,2010,2011,2012,2013,2014,2015];

	s.filters = true;

	/*
		Setejament del tipus de dades segons els parametres vinguts per la URL
	*/
 	if(!$state.params.id) 
 		$state.params.id = 'imports';

 	switch($state.params.id){
		case 'exports':
 			s.title = "Exportació d'armes";
 			break;
		default:
			s.title = "Importació d'armes";
 			break;
 	}
 	
	s.activemenu = $state.params.id
	s.showControls = true;

	// COnfiguració del gràfic del popup
	s.summary_options ={
		chart : {
            type: 'lineChart',
            height: 150,
            width:250,
            margin : {
                top: 20,
                right: 20,
                bottom: 40,
                left: 55
            },
            color :['#bf1925'],
            x: function(d){ return d.x; },
            y: function(d){ return d.y; },
            useInteractiveGuideline: true,
            yAxis : {
            	axisLabel : s.title + " (M$)",
            	axisLabelDistance: -10
            }
        }
    }
    // Configuració pel gràfic de la pantalla estadístiques
	DataInfo.type = {
        chart: {
            type: 'lineChart',
            height: 450,
            margin : {
                top: 20,
                right: 20,
                bottom: 40,
                left: 55
            },
            x: function(d){ return d.x; },
            y: function(d){ return d.y; },
            useInteractiveGuideline: true
        }
    };

	s.info = DataInfo;
	s.menu = {
		filter : false,
		menu: false
	}
	// Configuració dels colors a partir de l'objecte DataInfo
	s.defaultFills = angular.copy(DataInfo.pallette)

	// Configuració del mapa
	s.mapObject = {
	  scope: 'world',
	  options: {
	  },
	  responsive: true,
	  fills: s.defaultFills,
	  data :{
	  	"RUS" :{fill : "3456345"}
	  }
	}

	s.mapPlugins = {
	  	bubbles: null
	}
	s.mapPluginData = {
	  bubbles: []
	};
	// Funció per posar color al cercles segons el rang que pertoqui
	s.getScale  = function(_bubles){
		s.min = Enumerable.From(_bubles).Where("$[" + s.year + "] > 0").Min("$[" + s.year + "]");
		s.max = Enumerable.From(_bubles).Where("$[" + s.year + "] > 0").Max("$[" + s.year + "]")
		        s.scale = d3.scale.linear()
		        .domain([s.min, s.max])
                .range([0,6]);
	}

	// Funció que agafa les dades del JSON i les posa al mapa
	s.getData = function(){
		$http.get('local.php?url=data/' + $state.params.id +'.json')
		.success(function(d){
			var _bubles = Enumerable.From(d)
			.Join(s.info.map , "$.Country" , "$.name" , function(x,y){
				return angular.merge(x,y);
			}).OrderByDescending().ToArray();

			s.current_data = _bubles;
			var year = s.year;
            s.getScale (s.current_data );

			s.changeYear();
		})
	}
	s.tooltip = {
		info : null,
		show : false,
		position : {top : 0 , left : 0 }
	}

		$(function() {
		    $( ".custom-tooltip" ).draggable();
		  });
		$($('datamap')).on('click', '.datamaps-bubble', function(e) {
		  //handle click here as well
		  var info = angular.fromJson($(this).attr('data-info'));
		  s.$apply(function(){
			  s.tooltip.position.top = e.clientY +'px'
			  s.tooltip.position.left = e.clientX + 'px'
			  s.tooltip.info = info.info;
			  s.tooltip.show = true;
			  console.log(s.tooltip)

		  })
		  
		})
	// Funció que permet canviar l'anu que es visualitza
	s.changeYear = function(_stop){
		if(_stop){
			if(angular.isDefined(stop)) {
				$interval.cancel(stop)
				stop = null;
				s.stop = false;
			}
		}
		if(s.year <= 2015 && s.year >= 2000){

        	s.getScale (s.current_data );
			s.mapPluginData.bubbles = Enumerable.From(s.current_data).Select(function(x){
				var color = s.scale(parseInt(x[s.year]));
				var _bubble = new Bubble(x ,parseInt(s.year) , s.scale)
				return _bubble;
			}).OrderByDescending().ToArray();
		}else if(s.year >2015){
			s.year = 2015;
		}else{
			s.year = 2000;
		}

		$rootScope.$watch('pallette', function(x){
				s.mapObject.data = x
		})
		$rootScope.year = parseInt(s.year);
	}

	// Listener de la variable year i controlar que no sigui més petit que 2000 o més gran que 2015
	s.$watch('year', function(x , y) {
        if(x && !isNaN(x) && s.year <= 2015 && s.year >= 2000){
        	s.year = x;
        }
    });

	s.setYear = function(year){
		s.year = year;
		if(angular.isDefined(stop)) {
			$interval.cancel(stop)
			stop = null;
			s.stop = false;
		}
		s.changeYear()
	}

	s.hidemenu = function(type){
		s.menu[type] = false;
	}
	s.$on('readyto' , function(x,i){
		s.getData();
	})
	if(s.info.map){
		s.getData();
	}
	s.resetData = function(){
		s.data.values = [];
		localStorage.removeItem('DataInfo')
	}
    s.country = null;
    s.data = {values : []}

    // Funció que permet afegir un país amb les seves dades als filtres
    s.selectCountry = function(model){
    	_data = s.current_data;
    	s.current_country = Enumerable.From(s.current_data).Where("$.id == '" + model + "'").ToArray();

    	if(s.current_country.length){
    		var country = new BarChart(s.current_country[0] , DataInfo.pallette[fills[s.data.values.length % 6]]);
    		s.data.values.push(country.values[0]);
    	}
    	DataInfo.graphic = s.data
    	localStorage.setItem('DataInfo' , angular.toJson(DataInfo));
    }
    s.removeData = function(key){
		s.data.values = Enumerable.From(s.data.values).Where("$.key != '" + key +"'").ToArray()
    }
    if(DataInfo.graphic)
		s.data = DataInfo.graphic;
}]);
var _data = {}